package Bio::GSC::Align;
#----------------------------------------------------------------------
# General Documentation - Header
#----------------------------------------------------------------------

=head1 NAME Bio::GSC::Align

=head1 DESCRIPTION

Bio::GSC::Align is part of the Bio::GSC bundle of perl modules
developed at the Genome Sequencing Center at Washington University,
St. Louis, MO, USA.

Bio::GSC::Align contains functions for aligning sequences.

=head1 ENVIRONMENT

MATRIX_HOME environment variable indicates the path to the matricies.

=head1 DEPENDENCIES

 Bio::GSC::ScoringMatrix

=head1 API

The application programming interface is described below. Class methods
begin with an uppercase letter, instance methods with a lowercase
letter, and private methods with an underscore (these may not even be
documented).

=cut

#----------------------------------------------------------------------
# Directives
#----------------------------------------------------------------------
require 5.004;
require Exporter;
use strict;
use vars qw ($VERSION @ISA @EXPORT @EXPORT_OK);
$VERSION = "0.9";
@ISA = qw(Exporter);           
@EXPORT = qw();
@EXPORT_OK = qw();

use Bio::GSC::Constants;
use Bio::GSC::ScoringMatrix qw(
	scorePair
	LoadMatrix
	AlterMatrix
	PostMatrix);

#----------------------------------------------------------------------
# Class Variables
#----------------------------------------------------------------------

#----------------------------------------------------------------------
# Method Documentation
#----------------------------------------------------------------------

=head2 methodName()

Description:

 Usage:

=cut


#----------------------------------------------------------------------
# General Documentation - Footer
#----------------------------------------------------------------------

=head1 SEE ALSO

see other Bio::GSC modules.

=head1 AUTHOR

Ian Korf (ikorf@sapiens.wustl.edu)

=head1 REFERENCES

http://sapiens.wustl.edu/~ikorf/BioGSC

=head1 ACKNOWLEDGEMENTS

This software was developed at the Genome Sequencing Center at
Washington Univeristy, St. Louis, MO.

=head1 COPYRIGHT

Copyright (C) 1998 Washington University, St. Louis, MO, USA.
All Rights Reserved.

=head1 DISCLAIMER

This software is provided "as is" without warranty of any kind.

=cut


1;

