package Bio::GSC::Metric::Xpound;
#----------------------------------------------------------------------
# General Documentation - Header
#----------------------------------------------------------------------

=head1 NAME Bio::GSC::Metric::Xpound

=head1 DESCRIPTION

Bio::GSC::Metric::Xpound is part of the Bio::GSC bundle of perl modules
developed at the Genome Sequencing Center at Washington University,
St. Louis, MO, USA.

Bio::GSC::Metric::Xpound is a plug-in parser to xpound.

=head1 DEPENDENCIES

 Bio::GSC::Metric

=cut

#----------------------------------------------------------------------
# Directives
#----------------------------------------------------------------------
require 5.004;
require Expoter;
use strict;
use vars qw ($VERSION @ISA @EXPORT @EXPORT_OK);
$VERSION = "0.9";
@ISA = qw(Exporter);           
@EXPORT = qw();
@EXPORT_OK = qw();

use Bio::GSC::Metric;;

#----------------------------------------------------------------------
# Class Variables/Methods
#----------------------------------------------------------------------

#----------------------------------------------------------------------
# parse
#----------------------------------------------------------------------

sub parse {
	my ($this, $file) = @_;
	open(XP, "<$file") or die "ERROR: can't open file $file\n";
	my @plus;
	my @minus;
	while (<XP>) {
		my ($ps, $ms) = split(/\s+/, $_);
		push @plus, $ps;
		push @minus, $ms;
	}
	$this->{'plus'} = \@plus;
	$this->{'minus'} = \@minus;
}


#----------------------------------------------------------------------
# General Documentation - Footer
#----------------------------------------------------------------------

=head1 SEE ALSO

 see other Bio::GSC modules.

=head1 AUTHOR

 Ian Korf (ikorf@sapiens.wustl.edu)

=head1 REFERENCES

 http://genome.wustl.edu/gsc/staff/ikorf/Bio::GSC

=head1 ACKNOWLEDGEMENTS

 This software was developed at the Genome Sequencing Center at
 Washington Univeristy, St. Louis, MO.

=head1 COPYRIGHT

 Copyright (C) 1998 Washington University, St. Louis, MO, USA.
 All Rights Reserved.

=head1 DISCLAIMER

This software is provided "as is" without warranty of any kind.

=cut


1;

