

#
# this file is copyright (c) GRL limited (1997). It can be distributed
# under the GNU Public License. See GNULICENSE for more details.
# Notice that this comes with NO WARRANTY of any implied use.
#


#
# Email ewan (birney@sanger.ac.uk) with moans and complaints.
#

#
# Sorry about the lack of documentation.
#

package DomainSet;


use Domain;
use Carp;
use GD;

use vars qw($AUTOLOAD);


my %fields = ( 
	      seqname  => undef,
	      "length" => undef,
	      domain => undef );

sub show_ascii {
    my $self = shift;
    my $file = shift;
    my $doout=shift;
    my $dom;

    foreach $dom( @{$self->{'domain'}} ) {
	print $file sprintf("%-12s %d %d %4.2f\n",$dom->name(),$dom->start(),$dom->end(),$dom->bits());
	if( $doout == 1 ) {
	    print "\n";
	    print $file $dom->hmm_output();
	    print "\n";
	}
    }

}

sub show_scandb {
    my $self = shift;
    my $file = shift;
    my $name = shift;

    foreach $dom( @{$self->{'domain'}} ) {
#print "$seqname $start $end $name $model_start $model_end $score\n";

	print $file sprintf("%s %d %d %-12s %d %d %4.2f\n",$name,$dom->start(),$dom->end(),$dom->name(),$dom->dom_start(),$dom->dom_end(),$dom->bits());
    }

}


sub show_html {
    my $self = shift;
    my $file = shift;
    my $html_root = shift; # has desc directory...
    my $do_java= shift;
    my $dom;
    my $name;
    my @domarr;

    if( !$file) {
	carp("Attempting to make HTML output with no file stream... nope!");
	return 0;
    }
    $name = $self->seqname();

    print $file "Sequence $name - Domain organisation<p><CENTER><table  ALIGN=CENTER BORDER=5 CELLSPACING=0 CELLPADDING=5><tr ALIGN=CENTER><th>Domain</th><th>Start</th><th>End</th><th>Bits</th><th>Alignment</th></tr>\n";
    
    @domarr = @{$self->domain()};
    
    $num = 0;

    foreach $dom ( @domarr ) {
	print $file sprintf("<tr><td><a href=\"$html_root/%s.shtml\">%s</a></td><td ALIGN=RIGHT>%6d</td><td ALIGN=RIGHT>%6d</td><td ALIGN=RIGHT>%.2f</td><td><a href=\"#align%d\">Align</a></td></tr>\n",$dom->name(),$dom->name(),$dom->start(),$dom->end(),$dom->bits(),$num++);
    }

    print $file "</table></CENTER><hr>\n";
    
    
    if( $do_java == 1 ) {
	print $file "\n<p><CENTER><APPLET CODE=\"sv.Viewer\" CODEBASE=\"http://genome.wustl.edu/eddy/java/\" WIDTH = 200 HEIGHT = 30>\n";
	print $file sprintf("<PARAM NAME=\"DATA\" VALUE=\"%s %d %d ",$self->seqname(),$num,$self->length());
    
        @domarr = @{$self->domain()};


        foreach $dom ( @domarr ) {
	    print $file sprintf (" %s",$dom->name());
        }

        foreach $dom ( @domarr ) {
	    print $file sprintf (" %.2f",$dom->bits());
        }

        foreach $dom ( @domarr ) {
	    print $file sprintf (" %d",$dom->start());
        }

        foreach $dom ( @domarr ) {
	    print $file sprintf (" %d",$dom->end());
        }

        print $file "\"></APPLET></CENTER>\n";
    }
	

    $num = 0;

    foreach $dom ( @domarr ) {
	print sprintf("<a name=\"align%d\">Alignment of %s to %d-%d</a><p>\n<pre>\n",$num++,$dom->name(),$dom->start(),$dom->end());
	print $dom->hmm_output();
	print "\n</pre>\n";
    }

}
    
    
sub gif_string {
    my $self = shift;
    my $im;
    my $fac = 1;

    $im = new GD::Image(300,$fac*$self->length()+50);

#    $im = new GD::Image(100,100);

    $white = $im->colorAllocate(255,255,255);
    $black = $im->colorAllocate(0,0,0);       
    $red = $im->colorAllocate(255,0,0);      
    $blue = $im->colorAllocate(0,0,255);

    $im->transparent($white);
    $im->interlaced('true');



    @domarr = @{$self->domain};

    $prev = 0;
    $top = $fac*$self->length();
    

    foreach $dom (@domarr ) {
	$name = $dom->name();
	
	print STDERR "$top $prev $name\n";
	# draw line connecting this


	$im->filledRectangle(40,$prev+20,60,($fac*$dom->start())+20,$black);

	# draw rectangle for domain 

	$im->filledRectangle(25,($fac*$dom->start())+20,75,($fac*$dom->end())+20,$red);
	
	$im->string(gdLargeFont,100,20+($fac*($dom->start() + ($dom->end() - $dom->start())/2)),$name,$black);


	$prev = $fac*$dom->end();
    }

    $im->filledRectangle(40,$prev+20,60,($fac*$self->length())+20,$black);

    return $im->gif;
}
    

    
    
	

sub pfam_domain_structure {
    my $self = shift;
    my $pfd  = shift; # pfam database
    my $seqfile = shift;
    my $monitor_r = shift;
    my $repfile = shift;
    my $num = 0;

    if( $monitor_r && $monitor_r > 0 ) {
	
    } else {
	$monitor_r = (-1);
    }

    my $pfm;
    my $domset;

    if( !(-e $seqfile) ) {
	carp("Sequence file $seqfile is does not exist, and so I am dubious about its sequence ;)");
	return 0;
    }

    foreach $pfm ( @{$pfd->{domain}} ) {
	if( ($monitor_r > 0) && ($num % $monitor_r) == 0 ) {
	    print $repfile sprintf("Searching domain $num [%s]\n",$pfm->name);
	}
	$name = $pfm->name();

	$domset = new DomainSet;
    
	$domset->pfam_model_domain($pfm,$seqfile);
	
	$self->add_DomainSet($domset);
	$num++;
    }

    return $self;
}

sub sort_by_start {
    my $self = shift;
    my @domarr;

    @domarr = @{$self->domain()};
 
    @domarr = sort {
	return ($a->start() <=> $b->start() );
    } @domarr;
    

    $self->domain(\@domarr);
    return $self;
}
    

sub comp_two_domains_start  {
}


sub pfam_model_domain {
    my $self = shift;
    my $pfm  = shift; # pfam model
    my $seqfile = shift;
    my ($prog,$thresh,$hmmfile,$name,$num,$str);
    
    $pfam_root = 
    $num = 0;
    $prog = $pfm->hmmprog();
    $thresh= $pfm->thresh();
    $hmmfile= $pfm->hmmfile();
    $name= $pfm->name();
    if( $pfm->random() == 1 ) {
	$rnd = sprintf(" -r %s ",$pfm->rndfile() );
    }else {
	$rnd = " ";
    }


    if(  !(open (HMMLSPIPE,"$prog -F -q -t $thresh $rnd $hmmfile $seqfile |")) ) {
	carp("Could not open the hmmls pipe [$prog -q -t $thresh $hmmfile $seqfile] $!");
	return 0;
    }

    

    $_ = <HMMLSPIPE>;

    if( !defined $_ ) {
	return 0;
    }

    while(1) {

	if( !($_ =~ /^[0-9]/) ) {
	    carp("Now Mis-parsed in hmm[fl]s system");
	}

	$dom = new Domain;
	if( $prog eq "hmmls") {
	    open(LENGTH,"hmmconv -S $hmmfile | grep '###MATCH' | wc -l |") || die "Could not open icky pipe for length $!";
	    $line = <LENGTH>;
	    $line =~ s/[^\d]//g;
	    $len = $line -1;

	    $dom->dom_start(1);
	    $dom->dom_end($len);
	    $dom->from_hmmls_string($_);
	} elsif ( $prog eq "hmmfs") {
	    $dom->from_hmmfs_string($_);
	} else {
	    carp("For Pfam Model $name, we have no program implementation");
	}

	$dom->name($name);
	$str = "";
	while( <HMMLSPIPE> ) {
	    /^[0-9]/ && last;
	    $str .= $_;
	}
	$dom->name($name);
	$dom->hmm_output($str);
	add_Domain($self,$dom);
	$num++;

	if( ! ($_ =~ /^[0-9]/) ) {
	    last;
	}
    }
	    
    close(HMMLSPIPE);

    if( $? ) {
	carp "Ok, just to force that point: the script failed on domain model $name\n";
    }

    return $num;
}


    

sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    
    my $self = {
	_permitted => \%fields,
	%fields, };

    $self->{domain} = [];

    bless $self, $class;
    return $self;
}

sub show {
    my $self = shift;
    my $file = shift;
    my $dom;

    foreach $dom ( @{$self->domain()} ) {
	print $file sprintf("Domain %s [%d-%d] Bits %.2f\n",$dom->name(),$dom->start(),$dom->end(),$dom->bits());
    }
}

sub each_Domain {
    my $self = shift;
    my @arr;

    @arr = @{$self->domain()};

    return @arr;
}
    
sub add_DomainSet {
    my $self = shift;
    my $doms = shift;
    my $dom;

    foreach $dom ( @{$doms->domain()} ) {
	add_Domain($self,$dom);
    }
    
    return $self;
}
    

sub add_Domain {
    my $self = shift;
    
    push(@{$self->{domain}},shift);
   
    return $self;
}

$hmmls_prog = "hmmls";

sub add_Domains_from_hmmls {
    my $self = shift;
    my $seqfile  = shift;
    my $hmmfile = shift;
    my $thresh = shift;
    my $dom;
    my $num = 0;
    
    if( !$thresh ) {
	$thresh = "15";
    }

    my $name = $hmmfile;
    $name =~ s/\..*$//g;
   
    if( !(open (HMMLSPIPE,"$hmmls_prog -q -t $thresh $hmmfile $seqfile |")) ) {
	carp("Could not open the hmmls pipe [$hmmls_prog -q -t $thresh $hmmfile $temporary_seq$$] $!");
	return 0;
    }

    while (<HMMLSPIPE>) {
	if( !/^[0-9]/ ) {
	    next;
	}

	$dom = new Domain;
	$dom->from_hmmls_string($_);

	$dom->name($name);

	add_Domain($self,$dom);
	$num++;
    }

    close(HMMLSPIPE);

    return $num;
}

sub AUTOLOAD {
    my $self = shift;
    my $type = ref($self) || warn "Ok, $self is not an object of mine!";
    my $name = $AUTOLOAD;
    $name =~ s/.*://; #get only the bit we want
    unless (exists $self->{_permitted}->{$name} ) {
	warn "In type $type, can't access $name $keys  ";
    }
    if (@_) {
	return $self->{$name} = shift;
    } else {
	return $self->{$name}
    }
}




    
sub DESTROY {  }

END { }       # module clean-up code here (global destructor)

1;            # modules must return true

