package Matrix;

my $joinString = " ";
my $horizontal = 0;
my $vertical = 1;
my $diagonal = 2;
local $| = 1;

use strict;
use Carp ;

use overload
    '+' => \&add,
    '-' => \&subtract,
    '*' => \&multiply,
    '==' => \&equals;

#sub AUTOLOAD {
#  no strict;
#  print STDERR "Matrix::AUTOLOAD for $AUTOLOAD\n";
#  die &Carp::longmess;
#}

sub DESTROY { return 1; }

sub isMatrix {
    my $variable = shift;
    my $val;
    my $debugging = 0;
    $debugging && print "recieved variable: ", ref $variable, "\n";
    eval{ $val = $variable->_assertAsMatrix };
    $debugging && (($val && print $val, "\n") || (print "undef\n"));
    return $val;
}

sub _assertAsMatrix {
    my $self;
    return 1;
}

sub new {
    my $class = shift;
    my $self = [];
    my $param = shift;
    my $i;

    if(not ref $param) {
# form new Matrix (rows, cols)
	my $rows = $param;
	my $cols = shift;
	if( (defined $cols) && (not ref $cols) ) {
	    for $i (0 .. $rows-1) {
		$#{$self->[$i]} = $cols-1;
	    }
	} else {
	    carp "could not make array with $rows, ".ref($cols);
	}
    } else {
# form new Matrix (Matrix, ...)
	my $i; my $j;
	my $rowStart = shift;
	if(defined $rowStart) {
# form of Matrix block - new Matrix (parentMatrix, rowStart, rowEnd, colStart, colEnd)
	    my $rowEnd = shift;
	    my $colStart = shift;
	    my $colEnd = shift;
	    my $row;
	    my $col;
	    $i = 0;
	    for $row ($rowStart .. $rowEnd) {
		$j = 0;
		for $col ($colStart .. $colEnd) {
		    $self->[$i][$j] = $param->[$row][$col];
		    $j++;
		}
		$i++;
	    }
	} else {
          if(isMatrix($param)) {
# form of new Matrix (parentMatrix) - create copy of parent Matrix
	        for $i (0 .. $param->rows-1) {
		      for $j (0 .. $param->cols-1) {
		          $self->[$i][$j] = $param->[$i][$j];
                  }
		  }
          } elsif ( (ref($param) eq 'ARRAY') && (ref(@{$param}[0]) eq 'ARRAY') ) {
              $self = $param;
          }
      }
    }
    bless $self, $class;
}

sub block {
    my $flag = shift;
    my @matricese = @_;
    my $block;
    my $rows;
    my $cols;    
    my $Matrix;
    my $i;
    my $j;
    my $ii;
    my $jj;

  SWITCH: {
      $flag == $vertical && do {
	  $rows = 0; $cols = 0;
	  foreach $Matrix (@matricese) {
	      $rows += $Matrix->rows;
	      $cols = ($Matrix->cols > $cols) ? $Matrix->cols : $cols;
	  }
	  $block = new Matrix($rows, $cols);
	  $block->zero;
	  $i = 0;
	  foreach $Matrix (@matricese) {
	      for $ii (0 .. $Matrix->rows-1) {
		  for $jj (0 .. $Matrix->cols-1) {
		      $block->[$i+$ii][$jj] = $Matrix->[$ii][$jj];
		  }
	      }
	      $i += $Matrix->rows;
	  }
	  return $block;
      };
      $flag == $horizontal && do {
	  $rows = 0; $cols = 0;
	  foreach $Matrix (@matricese) {
	      $rows = ($Matrix->rows > $rows) ? $Matrix->rows : $rows;
	      $cols+=$Matrix->cols;
	  }
	  $block = new Matrix($rows, $cols);
	  $block->zero;
	  $j = 0;
	  foreach $Matrix (@matricese) {
	      for $ii (0 .. $Matrix->rows-1) {
		  for $jj (0 .. $Matrix->cols-1) {
		      $block->[$ii][$j+$jj] = $Matrix->[$ii][$jj];
		  }
	      }
	      $j += $Matrix->cols;
	  }
	  return $block;
      };
      $flag == $diagonal && do {
	  $rows = 0; $cols = 0;
	  foreach $Matrix (@matricese) {
	      $rows+=$Matrix->rows;
	      $cols+=$Matrix->cols;
	  }
	  $block = new Matrix($rows, $cols);
	  $block->zero;
	  $i = 0; $j = 0;
	  foreach $Matrix (@matricese) {
	      for $ii (0 .. $Matrix->rows-1) {
		  for $jj (0 .. $Matrix->cols-1) {
		      $block->[$i+$ii][$j+$jj] = $Matrix->[$ii][$jj];
		  }
	      }
	      $i += $Matrix->rows;
	      $j += $Matrix->cols;
	  }
	  return $block;
      };
  }
    return undef
}

sub toString {
    my $self = shift;
    my $colSeparator = shift;
    my $startRow = shift;
    my $endRow = shift;
    my @list = ();
    my $row;
    my $debugging=0;

    $colSeparator || ($colSeparator = $joinString);
    if($startRow && not defined $endRow) { $endRow = $startRow; $startRow = ""; }
    if(not defined $endRow) { $endRow = "\n"; }
    if(not defined $startRow) { $startRow = ""; }

    for $row ( @{$self} ) {
	push @list, ($startRow.join ($colSeparator, @{$row}).$endRow);
    }

    return join("", @list);
}

sub rows {
    my $self = shift;
    
    scalar(@{$self});
}

sub cols {
    my $self = shift;

    scalar(@{$self->[0]});
}

sub forEachComponent {
    my $self = shift;
    my $func = shift;
    my ($i, $j);

    for $i (@{$self}) {
	for $j (@{$i}) {
	    $j = &$func($j);
	}
    }

    return $self;
}

sub component {
    my $self = shift;
    my $i = shift;
    my $j = shift;
    my $val = shift;

    if( ($i < $self->rows) && ($j < $self->cols) ) {
      if(defined $val) { $self->[$i][$j] = $val; } else { $self->[$i][$j]; }
    } else {
      carp "Atempted to call component with out of range parameters $i, $j for matrix "
        , $self->rows, ", ", $self->cols;
    }
}

sub row {
    my $self = shift;
    my $row = shift;
    my $debugging = 0;

    if (ref($_[0]) eq "ARRAY") {
      $debugging && print "sent a reference ", ref($_[0]), " in @_\n";
      @_ = @{$_[0]};
      $debugging && print "now have @_\n";
    }

    $debugging && print "row $row being set to (", join(',', @_), ")\n";
    if($row < $self->rows) {
      if(scalar(@_) == $self->cols) {
        $self->[$row] = [@_];
        $debugging && print "row $row is set to (", join(',', @{$self->[$row]}), ")\n";
        return 1;
      } else {
        carp "Attempted to assign an array of width ", scalar(@_), " to matrix of width ", $self->cols;
        return 0;
      }
    } else {
      carp"attempted to alter row $row of matrix with only", $self->rows, " rows";
      return 0;
    }
}

sub add {
    my $ob1 = shift;
    my $ob2 = shift;
    
    if( not &isMatrix($ob2) ) {
	return undef;
    }
    
    my $rows = $ob1->rows;
    my $cols = $ob1->cols;
    my $i;
    my $j;
    
    if( ($rows == $ob2->rows) && ($cols == $ob2->cols) ) {
	my $ans = new Matrix($rows, $cols);
	for $i ( 0 .. $rows-1 ) {
	    for $j (0 .. $cols-1) {
		$ans->[$i][$j] = $ob1->[$i][$j] + $ob2->[$i][$j];
	    }
	}
	return $ans;
    }
    
    return undef;
}

sub subtract {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    if( not &isMatrix($ob2) ) {
	return undef;
    }

    my $rows = $ob1->rows;
    my $cols = $ob1->cols;
    my $i;
    my $j;

    if( ($rows == $ob2->rows) && ($cols == $ob2->cols) ) {
	my $ans = new Matrix($rows, $cols);
	for $i ( 0 .. $rows-1 ) {
	    for $j (0 .. $cols-1) {
		$ans->[$i][$j] = $ob1->[$i][$j] - $ob2->[$i][$j];
	    }
	}
	return $ans;
    }

    return undef;
}

sub multiply {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    my $i;
    my $j;
    my $k;
    my $accum;
    my $debugging = 0;

    $debugging && print "Multiply\n";
    $debugging && print ref $ob2, "\n";
    if( &isMatrix($ob2) ) {
	$debugging && print "Multiplying matrix by matrix\n";
	if($ob1->cols == $ob2->rows) {
	    $debugging && print "They are compatible\n";
	    my $ans = new Matrix($ob1->rows, $ob2->cols);
	    for $i ( 0 .. $ob1->rows-1 ) {
		for $j ( 0 .. $ob2->cols-1 ) {
		    $accum = 0;
		    for $k ( 0 .. $ob1->cols-1 ) {
			$accum += $ob1->[$i][$k] * $ob2->[$k][$j];
		    }
		    $ans->[$i][$j] = $accum;
		}
	    }
	    $debugging && print "Multiplied them and got\n", $ans->toString;
	    return $ans;
	} else {
	    $debugging && print "They are not the correct shape\n";
	    return undef;
	}
    } else {
	$debugging && print "Scaling matrix by $ob2\n";
	my $ans = new Matrix($ob1->rows, $ob1->cols);
	for $i ( 0 .. $ob1->rows-1 ) {
	    for $j ( 0 .. $ob1->cols-1 ) {
		$ans->[$i][$j] = $ob1->[$i][$j] * $ob2;
	    }
	}
	$debugging && print "Scaled\n";
	return $ans;
    }

    $debugging && print "could not multiply\n";
    return undef;
}

sub assign {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;
    my $debugging = 0;

    $debugging && print "In assign\n";
    $ob1 = new Matrix($ob2);
    $debugging && print $ob1->toString, $ob2->toString;
    return $ob1;
}

sub equals {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    if ($swap) { return 0 }
    my $i;
    my $j;

    if ( ($ob1->rows == $ob2->rows) && ($ob1->cols == $ob2->cols) ) {
	for $i ( 0 .. $ob1->rows-1 ) {
	    for $j ( 0 .. $ob1->cols-1 ) {
		if ( $ob1->component($i, $j) != $ob2->component($i, $j) ) { return 0; }
	    }
	}
	return 1;
    }
    return 0;
}

sub transpose {
    my $self = shift;
    my $rows = $self->rows;
    my $cols = $self->cols;
    
    my $i;
    my $j;
    my $ans = new Matrix($cols, $rows);
    
    for $i ( 0 .. $rows-1 ) {
	for $j ( 0 .. $cols-1 ) {
	    $ans->[$j][$i] = $self->[$i][$j];
	}
    }

    return $ans;
}

sub det {
    my $self = shift;

#if I am not square then my determinant is not defined
    if(not $self->square) { return undef; }

# if I have 2 rows & cols then return the determinant
    if($self->rows == 2) {
	return $self->[0][0] * $self->[1][1] - $self->[0][1] * $self->[1][0];
    }
# if I have only 1 element, then that is the determinant
    if($self->rows == 1) { return $self->[0][0]; }

# otherwise my determinant can be evaluated by finding the determinant of the
# coresponding Matrix of order n-1 or by eliminating columns untill det A is at 0,0

    my $working = new Matrix($self);
    my $row = $working->rows-1;
    my $sign = 0;
    my $i;
    my $ii;
    my $largest;
    my $current;

#gaussian elimination of Matrix to the triangular form
    for $row (0 .. $working->rows-1) {
	for($i = 0, $largest = 0; ($i < $working->rows); $i++) {
	    if(($current = abs($working->[$row][$i])) > $largest) {
		$ii = $i;
		$largest = $current;
	    }
	}
	if($largest==0) { return 0 };
	if($ii != $row) {
	    $sign++;
	    $working->rowSwap($ii, $row);
	}
	for($i = $row+1; $i < $working->rows; $i++) {
	    rowAdd($i, $row, -$working->[$i][$row] / $working->[$row][$row]);
	}
    }
# return the squares of the diagonal muiltiplied by the correct sign
    my $det = 0;
    for $i (0 .. $working->rows-1) {
	$current = $working->[$i][$i];
	$det+=$current * $current;
    }
    if($sign % 2) { $det = -$det; }

    return $det;
}

sub inverse {
    my $self = shift;
    my $ans;
    my $debugging = 0;

    if($self->isSquare) {
	$ans = new Matrix($self->rows, $self->rows);
	$debugging && print "entering identity for Matrix: ", ref($ans), "\n";
	$ans->identity;
      $debugging && print "blocking Matrix";
	$ans = block($horizontal, $self, $ans);
	$ans->echelon;

# check for a blank row in the echelon - in this case the Matrix is degenerate and there is no inverse
	my $i; my $j; my $empty;
	for $i (@{$self}) {
	    $empty = 1;
	    for $j (@{$i}) {
		if($j) { $empty = 0; last; }
	    }
	    if($empty) { last; }
	}
	if ($empty) { return undef; }

	$ans->rowCanonical(1);
	return new Matrix($ans, 0, $ans->rows-1, $self->cols, $ans->cols-1);
    }
    return undef;
}

sub zero {
    my $self = shift;
    my $i;
    my $j;
    my $debugging = 0;

# if invoked as package function return zero Matrix m*n otherwise set self to zero Matrix
    if(not ref $self) {
	$debugging && print "Invoked to create new Matrix\n";
	$self = new Matrix(shift, shift);
    }
    $debugging && print "filling Matrix with 0\nMatrix =\n", $self->toString;
    for $i ( @{$self} ) {
	for $j ( @{$i} ) { 
	    $j = 0;
	}
    }
    $debugging && print $self->toString;
    return $self;
}

sub identity {
    my $self = shift;
    my $i;
    my $j;
    my $debugging = 0;

# if invoked as package function return zeroidnetiy Matrix m*m otherwise set self to  I

    if(not ref $self) {
	$debugging && print "making new Matrix for the identity to fill\n";
	my $m = shift;
	$self = new Matrix($m, $m);
    }
    $debugging && print"identity for it ", ref $self, "\n";
    if($self->isSquare) {
	$self->zero;
	for $i ( 0 .. $self->rows-1 ) {
	    $self->component($i, $i, 1);
	}
	return $self;
    } else {
	$debugging && print "not square\n";
	return undef;
    }
}

sub trace {
    my $self = shift;
    my $i;
    my $accum = 0;

    if($self->isSquare) {
	for $i ( 0 .. $self->rows-1 ) {
	    $accum += $self->component($i, $i);
	}
    } else {
	return undef;
    }
    return $accum;
}

sub isSquare {
    my $self = shift;
    return $self->rows == $self->cols;
}

sub isDiagonal {
    my $self = shift;
    if(isSquare) {
	my $i;
	my $j;
	for $i ( 0 .. $self->rows-1 ) {
	    for $j ( 0 .. $self->rows-1 ) {
		if ($self->component($i, $j)) { return 1; }
	    }
	}
	return 1;
    }
    return 0;
}

sub isTriangular {
    my $self = shift;
    if(isSquare) {
	my $i;
	my $j;
	for $i ( 1 .. $self->rows-1 ) {
	    for $j ( $i .. $self->rows-1 ) {
		if ($self->component($i, $j)) { return 1; }
	    }
	}
	return 1;
    }
    return 0;
}

sub rowScale {
    my $self = shift;
    my $row = shift;
    my $scale = shift;
    my $i;

    for $i (@{$self->[$row]}) {
	$i*=$scale;
    }

    return $self;
}

sub colScale {
    my $self = shift;
    my $col = shift;
    my $scale = shift;
    my $i;

    for $i (0 .. $self->cols-1) {
	$self->[$i][$col] *= $scale;
    }

    return $self;
}

sub rowSwap {
    my $self = shift;
    my $r1 = shift;
    my $r2 = shift;
    my $rt;
    my $debugging = 0;

    $debugging && print "row swap for $r1 and $r2\nWe were ";
    $debugging && do { foreach ( @{$self} )  {print;} print "\n", $self->toString; };    
    $rt = $self->[$r1];
    $self->[$r1] = $self->[$r2];
    $self->[$r2] = $rt;
    $debugging && do { print "\nwe are  "; foreach ( @{$self} )  {print;} print "\n", $self->toString; };    

    return $self;
}

sub colSwap {
    my $self = shift;
    my $c1 = shift;
    my $c2 = shift;
    my $ct;
    my $i;

    for $i (0 .. $self->rows-1) {
	$ct = $self->[$i][$c1];
	$self->[$i][$c1] = $self->[$i][$c2];
	$self->[$i][$c2] = $ct;
    }

    return $self;
}

sub rowAdd {
    my $self = shift;
    my $r1 = shift;
    my $r2 = shift;
    my $scale = shift;
    my $i;

    for $i (0 .. $self->cols-1) {
	$self->[$r1][$i] = $self->[$r1][$i] + $self->[$r2][$i]*$scale;
    }

    return $self;
}

sub colAdd {
    my $self = shift;
    my $c1 = shift;
    my $c2 = shift;
    my $scale = shift;
    my $i;

    for $i (0 .. $self->rows-1) {
	$self->[$i][$c1] = $self->[$i][$c1] + $self->[$i][$c2] * $scale;
    }

    return $self;
}

sub rowAddScale {
    my $self = shift;
    my $r1 = shift;
    my $r2 = shift;
    my $scale1 = shift;
    my $scale2 = shift;
    my $i;

    for $i (0 .. $self->cols-1) {
	$self->[$r1][$i] = $self->[$r1][$i] * $scale1 + $self->[$r2][$i] * $scale2;
    }

    return $self;
}

sub colAddScale {
    my $self = shift;
    my $c1 = shift;
    my $c2 = shift;
    my $scale1 = shift;
    my $scale2 = shift;
    my $i;

    for $i (0 .. $self->rows-1) {
	$self->[$i][$c1] = $self->[$i][$c1] * $scale1 + $self->[$i][$c2] * $scale2;
    }

    return $self;
}

sub echelon {
    my $self = shift;
    my $row;
    my $col;
    my $i;
    my $j;
    my $debugging = 0;

    $col = 0;
    for($row = 0; $row < $self->rows && $col < $self->cols; $row++) {
	if($self->[$row][$col] == 0) {
          $debugging && print "found zero at $row, $col\n";
	    for($i = $row+1; $i < $self->rows && ($self->[$i][$col] == 0); $i++) {}
	    if($i < $self->rows) {
            $debugging && print "found a non-zero entry at $i, $col - swaping rows\n";
		$self->rowSwap($i, $row);
            $debugging && print $self->toString;
	    } else {
            $debugging && print "found no non-zero value - moving to the next column\n";
		$col++;
		$row--;
		next;
	    }
	}
# now do the pivot to cancel out all numbers below
      $debugging && print "pivoting from row $row, col $col\n";
	$j = $row+1;
	while($j < $self->rows) {
	    $self->rowAddScale($j, $row, $self->[$row][$col], -$self->[$j][$col]);
	    $j++;
	}
	$col++;
      $debugging && print "\n", $self->toString;
    }
    return $self;
}

sub rowCanonical {
    my $self = shift;
    my $flag = shift;
    my $row;
    my $i;
    my $j;

    unless($flag) { $self->echelon; }
    $row = $self->rows-1;
    while ($row >= 0) {
	for($j = 0; ($j < $self->cols) && ($self->[$row][$j] == 0); $j++) {}
	if($j == $self->cols) { $row--; next; }
	$self->rowScale($row, 1/$self->[$row][$j]);
	for($i = $row-1; $i >= 0; $i--) {
	    $self->rowAddScale($i, $row, $self->[$row][$j], -$self->[$i][$j]);
	}
	$row--;
    }
    return $self;
}

sub homSolution {
    my $self = shift;
    my $inRC = shift;
    my $row;
    my $col;
    my $leading;
    my $solutions;
    my @freeFlag;
    my @freeVars;
    my @tiedVars;
    my $debugging = 0;

    for $col (0 .. $self->cols-1) { $freeFlag[$col] = 0; }

    unless ($inRC) {
      ($self = $self)->rowCanonical;
    }
    $debugging && print $self->toString;
    for $row (0 .. $self->rows-1) {
      $debugging && print "\n$row\t";
      for ($col = 0; $col < $self->cols && $self->[$row][$col]==0; $col++) { }
      if($col < $self->cols-1) {
        $debugging && print "$col: ";
        for $col ($col + 1 .. $self->cols-1) {
          $debugging && print " $col";
          if($self->[$row][$col]) {
            $debugging && print " set $col ";
            $freeFlag[$col] = 1;
          }
        }
      }
    }
    for $col (0 .. $#freeFlag) {
      if($freeFlag[$col]) { push @freeVars, $col; } else { push @tiedVars, $col }
    }
    $debugging && print "got freeFlag of @freeFlag, freeVars of @freeVars and tiedVars of @tiedVars\n";    

    $solutions = new Matrix(scalar(@freeVars), $self->cols)->zero;
    for $row (0 .. @freeVars-1) {
      $solutions->[$row][$freeVars[$row]] = 1;
      for $col (0 .. $#tiedVars) {
        $debugging && print
          "row col $row, $col and tied free ", $tiedVars[$col], ", ", $freeVars[$row], "\n";
          $solutions->[$row][$tiedVars[$col]] = -$self->[$col][$freeVars[$row]];
      }
      $debugging && print $solutions->toString;
    }
    $debugging && print $solutions->toString;
    return $solutions;
}

sub eigenVectors {
    my $self = shift;
    my @eigenvectors;
    my $ev;
    my $M;
    my $i;
    my @s;
    my $unique;
    my $debugging = 0;

# handle case when we are passed reference to an array
    if(ref($_[0]) eq "ARRAY") {
      @_ = @{$_[0]};
    }

# calculate the eigenvalues for each eigenvector and push them onto @s
    for $ev (@_) {
      $debugging && print "eigenvalue $ev\n";
      $M = new Matrix($self);
      $debugging && print "got matrix\n", $M->toString;
      for $i (0 .. $self->rows-1) {
        $M->[$i][$i] -= $ev;
      }
      $debugging && print "got matrix\n", $M->toString;
      $M->rowCanonical;
      $debugging && print "row canonical\n", $M->toString;
      my $temp = $M->homSolution(1);
      push @s, @{$temp};
    }

    return bless \@s, 'Matrix'; # magic to turn array of arrays into a matrix!
}

1;

__END__

=head1 NAME

Matrix.pm - Perl Object for matricese

=head1 DESCRIPTION

B<Matrix.pm> Defines and impliments a Matrix and the 
operations which can be performed on it.  Matrix 
overloads the +, -, * and '==' operators.  It impliments autoload and
the nomethod function of overload, both to give confessions.  The parameters
passed to the unimplimented overloaded function are not printed in the
stack trace to prevent perpetual loops in the Carp module.

Matricese can hold any object as an element which overloads the +, == and
* operators.  They can not hold arrays as elements.

=head1 AUTHOR

Matthew Pocock Mail: mrp@sanger.ac.uk

=head1 Example

A simple example to get us started.

	#!/usr/local/bin/perl

	use Matrix;

        # create a new Sequence

	$R = new Matrix(2, 2);
	$R->component(0, 0, 1);
	$R->component(0, 1, 2);
	$R->component(1, 0, 2);
	$R->component(1, 1, 1);

	$M = new Matrix;
	$M->identity;

	$SUM = $R + $M;

	print $SUM->toString;

=head1 Creating a Matrix

=over 5

=itemC<new(rows, cols)>

Creates a new sequence Matrix with the specified number of rows and columns.
Currently can't initialize the Matrix content.

=item C<new(Matrix)>

creates a new Matrix that is a copy of $Matrix

=item C<new(Matrix, startRow, stopRow, startCol, stopCol)>

creates a new Matrix that contains the block within $Matrix, delimited by start
and stop row and col.

=item C<block(flag, M1, M2 ....)>

Returns a new Matrix that is the block Matrix defined by $M1... combined according
to $flag.  $flag takes one of the values $horizontal, $vertical or $diagonal. The
block Matrix will contain zero values where the matricese passed could not give
a value.

Use:

 $block = &Matrix::block($Matrix::diagonal, M1, M2);

This would put a Matrix in $block that had M1 and M2 on the diagonal, and zero
everywhere else.

=item C<zero>

Sets the Matrix to the zero Matrix.  All elements become zero.  Alternatively,
calling Matrix::&zero($i, $j) will return a new zero Matrix $i by $j.  In either
case it returns the matrix to allow chaining.

=item C<identity>

Sets a Matrix to the identity Matrix.  All elements on the leading diagonal
become 1, and all other elements become zero.  It leaves the Matrix unchangd
and returns C<undef> if the Matrix is not square.  Alternatively, if called as
Matrix::&identity($i) it will return a new identity Matrix $i square.  Either way,
the function returns the matrix to allow chaining.

=back

=head1 Using a Matrix

=head2 Operators

=over 5

=item C<add>

Adds two matricese together.  Used to impliment the overloading of
the '+' operator.

Use:

 $Manswer = $M1 + $M2;

As for any Matrix addition, $M1 and $M2 must both be matricese, both with
the same number of rows and columns.  If this is not the case then the
function returns C<undef>.  Otherwise, it returns a new Matrix, containing the
sum of $M1 and $M2.

=item C<subtract>

Subtracts one Matrix from another.  Used to impliment the overloading of
the '-' operator.

Use:

 $Manswer = $M1 - $M2;

As for any Matrix subtraction, $M1 and $M2 must both be matricese, both with
the same number of rows and columns.  If this is not the case then the
function returns C<undef>.  Otherwise, it returns a new Matrix, containing $M1
minus $M2.

=item C<multiply>

Multiplies two matricese, or a Matrix and a scaler.  Used to impliment the
overloading of the '*' operator.

Use:

 $Manswer = $M1 * $M2;
 $Manswer = $s * $M;
 $Manswer = $M * $s;

When used to multiply by a scaler, a Matrix scaled by the factor is returned.
When used for multiplying two matricese together, the number of columns in the first
Matrix must equal the number of rows in the second.  If this is not so then
C<undef> is returned.

=item C<assign>

Sets one Matrix equal to another by value.  Used to impliment the '=' operator.  It
is a wrapper around $N = new Matrix $M, but is more intuitive and (I think) easier to
read.  It returns the first matrix so that ($M = $N)->echelon will make a copy of $N
in $M, and then reduce $M to echelon form.  Not used for overloading as something is broken.

Use:

 $N = $M;

$N and $M can now be changed independantly

=item C<equals>

Checks whether two matricese are equal.  Returns true if they are and false if they
are not.  Used to impliment the overloading of the '=' operator.

Use:

 $ans = $M1 == $M2;

The function will return true only if the two matricese are equivelent.  That is, they
must have the same number of rows and of columns.  Also, every element ij of the first
Matrix must equal every element ij of the second.

=back

=head2 Variables

=over 5

=item C<$joinString>

This string is the one used to demarcate one element from the next.  It is a package
level variable, so is accesed like C<EMatrix::$joinString>.  It defaults to a single
space caracter.

=item C<$horizontal>

Constant to indicate a horizontal construction of a block Matrix

=item C<$vertical>

Constant to indicate a vertical construction of a block Matrix

=item C<$diagonal>

Constant to indicate a diagonal construction of a block Matrix

=back

=head2 Data access

=over 5

=item C<rows>

Returns the number of rows in a Matrix.  Assigning to this value will B<not> change the
shape of the Matrix.

Use:

 $rows = $M->rows:

=item C<cols>

Returns the number of columns in a Matrix.  Assigning to this value will B<not> change
the shape of the Matrix.

=item C<component>

Allows you to set and/or return the component i, j of a Matrix

Use:

 $val = $M->component(0, 3);
 $M->component(0, 2, 7);

As yet it does not support notation of the type C<$M->component($i, $j) = $val> as I
can not find any reasonably safe and legal way of accumplishing it.  Both forms
return the value of Matrix(i, j).  The assigment form returns the value of
Matrix(i, j) post assigment - i.e. $M->component($i, $j, $val) returns a scaler of 
value $val.

If the row or column is out of range, the command will give an informative error
message and return 0.  Otherwise, it will return the value $val.

=item C<row>

Sets an entire row of the matrix to the value of an array.  The first argument should
be the row to alter.  The array can then be passed by value, or by reference.  C<Row>
will work out what you meen for you!

Use:

 $M = new matrix(2, 4); # a matrix with 2 rows, each 4 wide
 $M->row(0, 8, 5, 6, 3);
 @array = (3, 8, 5, 4);
 $M->row(1, \@array));

If the row is outside the size of the matrix, or the size of the array is not correct
then an informative error message will be produced, and the command will return 0,
leaving the matrix unchanged.  Otherwise, it will return 1.

=item C<forEachComponent>

This function applies the function passed to each element of the matrix in turn, and
replaces each element with the return value of that function.

=back

=head2 C<Assertions>

=over 5

=item C<isMatrix>

returns true if the reference is a Matrix.  Otherwise, returns C<undef>.

use:

 &Matrix::isMatrix($ref);

=item C<isSquare>

Returns true if the Matrix is square and returns false otherwise.

=item C<isDiagonal>

Returns true if the Matrix is diagonal and returns false otherwise.  Must be square, and all entries not on
the leading diagonal must return false.

=item C<isTriangular>

Returns true if the Matrix is triangular, and false otherwise.  Must be square, and all entries below
the leading diagonal must return false.

=back

=head2 C<Other functions>

=over 5

=item C<toString>

Returns a string representation of a Matrix.  Places $joinString  between
each element, and delimits each row with C<'\n'>.  Optionaly, you can pass one, two
or three parameters to it.  The first parameter is taken to be the character
seperating columns within a row.  When two parameters are specified, the second is
taken to be the character seperating each row.  When three are used, the seccond
is the string at the beginning of each row, and the third is at the end of each row.

Use:

 $M->toString(" ", "\n"); # returns the matrix in the normal representation

 $M->toString(",", "|"); # returns the matrix with commas between each item,
and a bar between lines.

 $M->toString(",", "( ", " )"); # returns the matrix on a single line with commas between
each item in a row, and each row bracketed.

=item C<transpose>

Returns a new Matrix which is the transpose of your Matrix.

=item C<det>

Will return determinant of Matrix and C<undef> if the Matrix is not square.
Uses Det A = a00 for a Matrix of 1 element, Det A = a00*a11 - a10*a01 for
a 2 by 2 Matrix, and the Gausian elimination algorithm for anything larger.

=item C<inverse>

Returns a new Matrix which is the inverse of your Matrix, and C<undef>
if there is not one.  Returns C<undef> if the Matrix is not square.

=item C<trace>

Returns the trace of the Matrix - the sum of the leading diagonal.  If the
Matrix is not square then it returns C<undef>.

=item C<rowScale> and C<colScale>

Scales row or column i by factor f

Use:

 $M->rowScale($i, $f);
 $M->colScale($i, $f);

=item C<rowSwap> and C<colSwap>

Swap row or column i with row j

Use:

 $M->rowSwap($i, $j);
 $M->colSwap($i, $j);

=item C<rowAdd> and C<colAdd>

Add s times row or column j to row i

Use:

 $M->rowAdd($i, $j, $s);
 $M->colAdd($i, $j, $s);

=item C<rowAddScale> and C<colAddScale>

Combine rowAdd and rowScale or colAdd and colScale into one function.  row or column
i becomes row i * s + j * t.

Use:

 $M->rowAddScale($i, $j, $s, $t);
 $M->colAddScale($i, $j, $s, $t);

=item C<echelon>

Uses row operations to transform the Matrix to an echelon form Matrix.  Returns the
matrix to allow chaining.

Use:

 $M->echelon;

Remember kids - this will destroy the original contence of $M.  If you wish to find an
echelon form of $M without destroying it, make a copy first!

 $N = $M;
 $N->toEchelon;

=item C<rowCanonical>

Uses row operators to transform the Matrix into it's row canonical form.  Returns the
matrix to allow chaining.  The same pravisoes apply as for the echelon function.

Use:

 $M->rowCanonical;
 $E->rowCanonical(1);

In the first example, the Matrix $M will be transformed into it's row canonical form.
In the second example, the Matrix $E is presumed to already be an echelon Matrix,
and will be further reduced to the row canonical form.

= item C<homSolutions>

Returns a matrix which is composed of the row vectors that represent the basis of the
homogeneous system of linear equasions represented in the matrix.  If the matrix is already
in row canonical form then calling homSolutions with a non-zero parameter will cause
it not to recalculate the row canonical form, and will save on memory.  This function leaves
the original matrix unchanged.

Use:

 $M = new Matrix(3, 5);
 $M->row(0, [1, 2, -3, 2, -4]);
 $M->row(1, [2, 4, -5, 1, -6]);
 $M->row(2, [5, 10, -13, 4, -16]);

 $BASIS = $M->homSolutions;
 print $BASIS->toString;

= item C<eigenVectors>

Takes an array of eigenvalues, and computes the eigenvectors from them. The result is
returned as a matrix with each eigenvector in a row.  The eigenvalues can be passed by
value, or as a reference to an array.

=back














