package matrix;

my $joinString = " ";
my $horizontal = 0;
my $vertical = 1;
my $diagonal = 2;

use strict;

use overload
    "+" => \&add,
    "-" => \&subtract,
    "*" => \&multiply,
    "=" => \&assign,
    "==" => \&equals;

sub isMatrix {
    my $variable = shift;
    return eval($variable->_assertAsMatrix);
}

sub _assertAsMatrix {
    my $self;
    return $self;
}

sub new {
    my $class = shift;
    my $self = [];
    my $param = shift;
    my $i;

    if(not ref $param) {
# form new matrix (rows, cols)
	my $rows = $param;
	my $cols = shift;
	if( (defined $cols) && (not ref $cols) ) {
	    for $i (0 .. $rows-1) {
		$#{$self->[$i]} = $cols-1;
	    }
	} else {
# tried to make it with new matrix(number, ref)
	    die "could not make array with $rows, ".ref($cols);
	}
    } else {
# form new matrix (matrix, ...)
	my $i; my $j;
	my $rowStart = shift;
	if(defined $rowStart) {
# form of matrix block - new matrix (parentMatrix, rowStart, rowEnd, colStart, colEnd)
	    my $rowEnd = shift;
	    my $colStart = shift;
	    my $colEnd = shift;
	    my $row;
	    my $col;
	    $i = 0;
	    for $row ($rowStart .. $rowEnd) {
		$j = 0;
		for $col ($colStart .. $colEnd) {
		    $self->[$i][$j] = $param->[$row][$col];
		    $j++;
		}
		$i++;
	    }
	} else {
# form of new matrix (parentMatrix) - create copy of parent matrix
	    for $i (0 .. $param->rows-1) {
		for $j (0 .. $param->cols-1) {
		    $self->[$i][$j] = $param->[$i][$j];
		}
	    }
	}
    }

    bless $self, $class;
}

sub block {
    my $flag = shift;
    my @matricese = @_;
    my $block;
    my $rows;
    my $cols;    
    my $matrix;
    my $i;
    my $j;
    my $ii;
    my $jj;

  SWITCH: {
      $flag == $vertical && do {
	  $rows = 0; $cols = 0;
	  foreach $matrix (@matricese) {
	      $rows += $matrix->rows;
	      $cols = ($matrix->cols > $cols) ? $matrix->cols : $cols;
	  }
	  $block = new matrix($rows, $cols);
	  $block->zero;
	  $i = 0;
	  foreach $matrix (@matricese) {
	      for $ii (0 .. $matrix->rows-1) {
		  for $jj (0 .. $matrix->cols-1) {
		      $block->[$i+$ii][$jj] = $matrix->[$ii][$jj];
		  }
	      }
	      $i += $matrix->rows;
	  }
	  return $block;
      };
      $flag == $horizontal && do {
	  $rows = 0; $cols = 0;
	  foreach $matrix (@matricese) {
	      $rows = ($matrix->rows > $rows) ? $matrix->rows : $rows;
	      $cols+=$matrix->cols;
	  }
	  $block = new matrix($rows, $cols);
	  $block->zero;
	  $j = 0;
	  foreach $matrix (@matricese) {
	      for $ii (0 .. $matrix->rows-1) {
		  for $jj (0 .. $matrix->cols-1) {
		      $block->[$ii][$j+$jj] = $matrix->[$ii][$jj];
		  }
	      }
	      $j += $matrix->cols;
	  }
	  return $block;
      };
      $flag == $diagonal && do {
	  $rows = 0; $cols = 0;
	  foreach $matrix (@matricese) {
	      $rows+=$matrix->rows;
	      $cols+=$matrix->cols;
	  }
	  $block = new matrix($rows, $cols);
	  $block->zero;
	  $i = 0; $j = 0;
	  foreach $matrix (@matricese) {
	      for $ii (0 .. $matrix->rows-1) {
		  for $jj (0 .. $matrix->cols-1) {
		      $block->[$i+$ii][$j+$jj] = $matrix->[$ii][$jj];
		  }
	      }
	      $i += $matrix->rows;
	      $j += $matrix->cols;
	  }
	  return $block;
      };
  }
    return undef
}

sub toString {
    my $self = shift;
    my $returnVal = "";
    my $row;

    for $row ( @{$self} ) {
	$returnVal.=(join($joinString, @{$row}) . "\n");
    }

    return $returnVal;
}

sub rows {
    my $self = shift;
    
    @{$self} + 0;
}

sub cols {
    my $self = shift;

    @{$self->[0]} + 0;
}

sub component {
    my $self = shift;
    my $i = shift;
    my $j = shift;
    my $val = shift;

    if(defined $val) { $self->[$i][$j] = $val; } else { $self->[$i][$j]; }
}

sub add {
    my $ob1 = shift;
    my $ob2 = shift;
    
    if( not &isMatrix($ob2) ) {
	return undef;
    }
    
    my $rows = $ob1->rows;
    my $cols = $ob1->cols;
    my $i;
    my $j;
    
    if( ($rows == $ob2->rows) && ($cols == $ob2->cols) ) {
	my $ans = new matrix($rows, $cols);
	for $i ( 0 .. $rows-1 ) {
	    for $j (0 .. $cols-1) {
		$ans->[$i][$j] = $ob1->[$i][$j] + $ob2->[$i][$j];
	    }
	}
	return $ans;
    }
    
    return undef;
}

sub subtract {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    if( not &isMatrix($ob2) ) {
	return undef;
    }

    my $rows = $ob1->rows;
    my $cols = $ob1->cols;
    my $i;
    my $j;

    if( ($rows == $ob2->rows) && ($cols == $ob2->cols) ) {
	my $ans = new matrix($rows, $cols);
	for $i ( 0 .. $rows-1 ) {
	    for $j (0 .. $cols-1) {
		$ans->[$i][$j] = $ob1->[$i][$j] - $ob2->[$i][$j];
	    }
	}
	return $ans;
    }

    return undef;
}

sub multiply {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    my $i;
    my $j;
    my $k;
    my $accum;

    if( &isMatrix($ob2) ) {
	if($ob1->cols == $ob2->rows) {
	    my $ans = new matrix($ob1->rows, $ob2->cols);
	    for $i ( 0 .. $ob1->rows-1 ) {
		for $j ( 0 .. $ob2->cols-1 ) {
		    $accum = 0;
		    for $k ( 0 .. $ob1->cols-1 ) {
			$accum += $ob1->[$i][$k] * $ob2->[$k][$j];
		    }
		    $ans->[$i][$j] = $accum;
		}
	    }
	    return $ans;
	} else {
	    return undef;
	}
    } else {
	my $ans = new matrix($ob1->rows, $ob1->cols);
	for $i ( 0 .. $ob1->rows-1 ) {
	    for $j ( 0 .. $ob1->cols-1 ) {
		$ans->[$i][$j] = $ob1->[$i][$j] * $ob2;
	    }
	}
	return $ans;
    }

    return undef;
}

sub assign {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    if ($swap) {
	$ob2 = new matrix($ob1);
    } else {
	$ob1 = new matrix($ob2);
    }
}

sub equals {
    my $ob1 = shift;
    my $ob2 = shift;
    my $swap = shift;

    if ($swap) { return 0 }
    my $i;
    my $j;

    if ( ($ob1->rows == $ob2->rows) && ($ob1->cols == $ob2->cols) ) {
	for $i ( 0 .. $ob1->rows-1 ) {
	    for $j ( 0 .. $ob1->cols-1 ) {
		if ( $ob1->component($i, $j) != $ob2->component($i, $j) ) { return 0; }
	    }
	}
	return 1;
    }
    return 0;
}

sub transpose {
    my $self = shift;
    my $rows = $self->rows;
    my $cols = $self->cols;
    
    my $i;
    my $j;
    my $ans = new matrix($cols, $rows);
    
    for $i ( 0 .. $rows-1 ) {
	for $j ( 0 .. $cols-1 ) {
	    $ans->[$j][$i] = $self->[$i][$j];
	}
    }

    return $ans;
}

sub det {
    my $self = shift;

#if I am not square then my determinant is not defined
    if(not $self->square) { return undef; }

# if I have 2 rows & cols then return the determinant
    if($self->rows == 2) {
	return $self->[0][0] * $self->[1][1] - $self->[0][1] * $self->[1][0];
    }
# if I have only 1 element, then that is the determinant
    if($self->rows == 1) { return $self->[0][0]; }

# otherwise my determinant can be evaluated by finding the determinant of the
# coresponding matrix of order n-1 or by eliminating columns untill det A is at 0,0

    my $working = new matrix($self);
    my $row = $working->rows-1;
    my $sign = 0;
    my $i;
    my $ii;
    my $largest;
    my $current;

#gaussian elimination of matrix to the triangular form
    for $row (0 .. $working->rows-1) {
	for($i = 0, $largest = 0; ($i < $working->rows); $i++) {
	    if(($current = abs($working->[$row][$i])) > $largest) {
		$ii = $i;
		$largest = $current;
	    }
	}
	if($largest==0) { return 0 };
	if($ii != $row) {
	    $sign++;
	    $working->rowSwap($ii, $row);
	}
	for($i = $row+1; $i < $working->rows; $i++) {
	    rowAdd($i, $row, -$working->[$i][$row] / $working->[$row][$row]);
	}
    }
# return the squares of the diagonal muiltiplied by the correct sign
    my $det = 0;
    for $i (0 .. $working->rows-1) {
	$current = $working->[$i][$i];
	$det+=$current * $current;
    }
    if($sign % 2) { $det = -$det; }

    return $det;
}

sub inverse {
    my $self = shift;
    my $ans;
    if($self->isSquare) {
	$ans = new matrix($self->rows, $self->rows);
	print "entering identity for matrix ", ref($ans), "\n";
	$ans->identity;
print "blocking matrix";
	$ans = block($horizontal, $self, $ans);
	$ans->echelon;

# check for a blank row in the echelon - in this case the matrix is degenerate and there is no inverse
	my $i; my $j; my $empty;
	for $i (@{$self}) {
	    $empty = 1;
	    for $j (@{$i}) {
		if($j) { $empty = 0; last; }
	    }
	    if($empty) { last; }
	}
	if ($empty) { return undef; }

	$ans->rowCanonical(1);
	return new matrix($ans, 0, $ans->rows-1, $self->cols, $ans->cols-1);
    }
    return undef;
}

sub zero {
    my $self = shift;
    my $i;
    my $j;

# if invoked as package function return zero matrix m*n otherwise set self to zero matrix
    if(not ref $self) {
	print "Invoked to create new matrix\n";
	$self = new matrix(shift, shift);
    }
    print "filling matrix with 0\nMatrix =\n", $self->toString;
    for $i ( @{$self} ) {
	for $j ( @{$i} ) { print ":$j:\n";
	    $j = 0;
	}
    }

    return $self;
}

sub identity {
    my $self = shift;
    my $i;
    my $j;


# if invoked as package function return zeroidnetiy matrix m*m otherwise set self to  I

    if(not ref $self) {
	print "making new matrix for the identity to fill\n";
	my $m = shift;
	$self = new matrix($m, $m);
    }
    print"identity for it ", ref $self, "\n";
    if($self->isSquare) {
	$self->zero;
	for $i ( 0 .. $self->rows-1 ) {
	    $self->component($i, $i, 1);
	}
	return $self;
    } else {
	return undef;
    }
}

sub trace {
    my $self = shift;
    my $i;
    my $accum = 0;

    if($self->isSquare) {
	for $i ( 0 .. $self->rows-1 ) {
	    $accum += $self->component($i, $i);
	}
    } else {
	return undef;
    }
    return $accum;
}

sub isSquare {
    my $self = shift;
    return $self->rows == $self->cols;
}

sub isDiagonal {
    my $self = shift;
    if(isSquare) {
	my $i;
	my $j;
	for $i ( 0 .. $self->rows-1 ) {
	    for $j ( 0 .. $self->rows-1 ) {
		if ($self->component($i, $j)) { return 1; }
	    }
	}
	return 1;
    }
    return 0;
}

sub isTriangular {
    my $self = shift;
    if(isSquare) {
	my $i;
	my $j;
	for $i ( 1 .. $self->rows-1 ) {
	    for $j ( $i .. $self->rows-1 ) {
		if ($self->component($i, $j)) { return 1; }
	    }
	}
	return 1;
    }
    return 0;
}

sub rowScale {
    my $self = shift;
    my $row = shift;
    my $scale = shift;
    my $i;

    for $i (@{$self->[$row]}) {
	$i*=$scale;
    }
}

sub colScale {
    my $self = shift;
    my $col = shift;
    my $scale = shift;
    my $i;

    for $i (0 .. $self->cols-1) {
	$self->[$i][$col] *= $scale;
    }
}

sub rowSwap {
    my $self = shift;
    my $r1 = shift;
    my $r2 = shift;
    my $rt;

    $rt = $self->[$r1];
    $r1 = $self->[$r2];
    $r2 = $rt;
}

sub colSwap {
    my $self = shift;
    my $c1 = shift;
    my $c2 = shift;
    my $ct;
    my $i;

    for $i (0 .. $self->rows-1) {
	$ct = $self->[$i][$c1];
	$self->[$i][$c1] = $self->[$i][$c2];
	$self->[$i][$c2] = $ct;
    }
}

sub rowAdd {
    my $self = shift;
    my $r1 = shift;
    my $r2 = shift;
    my $scale = shift;
    my $i;

    for $i (0 .. $self->cols-1) {
	$self->[$r1][$i] = $self->[$r1][$i] + $self->[$r2][$i]*$scale;
    }
}

sub colAdd {
    my $self = shift;
    my $c1 = shift;
    my $c2 = shift;
    my $scale = shift;
    my $i;

    for $i (0 .. $self->rows-1) {
	$self->[$i][$c1] = $self->[$i][$c1] + $self->[$i][$c2] * $scale;
    }
}

sub rowAddScale {
    my $self = shift;
    my $r1 = shift;
    my $r2 = shift;
    my $scale1 = shift;
    my $scale2 = shift;
    my $i;

    for $i (0 .. $self->cols-1) {
	$self->[$r1][$i] = $self->[$r1][$i] * $scale1 + $self->[$r2][$i] * $scale2;
    }
}

sub colAddScale {
    my $self = shift;
    my $c1 = shift;
    my $c2 = shift;
    my $scale1 = shift;
    my $scale2 = shift;
    my $i;

    for $i (0 .. $self->rows-1) {
	$self->[$i][$c1] = $self->[$i][$c1] * $scale1 + $self->[$i][$c2] * $scale2;
    }
}

sub echelon {
    my $self = shift;
    my $row;
    my $col;
    my $i;
    my $j;

    $col = 0;
    for($row = 0; $row < $self->rows && $col < $self->cols; $row++) {
# for each row in self
# if the entry is zero search for a non-zero value to swap it with
	if($self->[$row][$col] == 0) {
	    for($i = 1; $i < $self->rows && ($self->[$i][$col] == 0); $i++) {}
	    if($i < $self->rows) {
# if there is one then replace it
		$self->rowSwap($i, $row);
	    } else {
# if not then redo this with the next column
		$col++;
		$row--;
		next;
	    }
	}
# now do the pivot to cancel out all numbers below
	$j = $row+1;
	while($j < $self->rows) {
	    $self->rowAddScale($j, $row, $self->[$row][$col], -$self->[$j][$col]);
	    $j++;
	}
	$col++;
    }
    return $self;
}

sub rowCanonical {
    my $self = shift;
    my $flag = shift;
    my $row;
    my $i;
    my $j;

    unless($flag) { $self->echelon; }
    $row = $self->rows-1;
    while ($row >= 0) {
	for($j = 0; ($j < $self->cols) && ($self->[$row][$j] == 0); $j++) {}
	if($j == $self->cols) { $row--; next; }
	$self->rowScale($row, 1/$self->[$row][$j]);
	for($i = $row-1; $i >= 0; $i--) {
	    $self->rowAddScale($i, $row, $self->[$row][$j], -$self->[$i][$j]);
	}
	$row--;
    }
}

sub eigenvalues {
    my $self = shift;
    my $pol;
    my @roots;

    die "eigenvalues not implimented yet";
    $pol = $self->polynomial;
    @roots = roots($pol);

    return @roots;
}

sub eigenvectors {
    my $self = shift;

    my @eigenvalues = @_;
 #add the code in here .  Oh shit.
    die "eigenvectors not implimented yet";
}
1;

__END__

=head1 NAME

matrix.pm - Perl Object for matricese

=head1 DESCRIPTION

B<matrix.pm> Defines and impliments a matrix and the 
operations which can be performed on it.  Matrix 
overloads the +, -, *, '==' and '=' operators.

=head1 AUTHOR

Matthew Pocock Mail mrp@sanger.ac.uk

=head1 Example

A simple example to get us started.

	#!/usr/local/bin/perl

	use matrix;

        # create a new Sequence

	$R = new matrix(2, 2);
	$R->component(0, 0, 1);
	$R->component(0, 1, 2);
	$R->component(1, 0, 2);
	$R->component(1, 1, 1);

	$M = new matrix;
	$M->identity;

	$SUM = $R + $M;

	print $SUM->toString;

=head1 Method Calls


=head1 Creating a matrix

=over 5

=itemC<new(rows, cols)>

Creates a new sequence matrix with the specified number of rows and columns.
Currently can't initialize the matrix content.

=item C<new(matrix)>

creates a new matrix that is a copy of $matrix

=item C<new(matrix, startRow, stopRow, startCol, stopCol)>

creates a new matrix that contains the block within $matrix, delimited by start
and stop row and col.

=item C<block(flag, M1, M2 ....)>

Returns a new matrix that is the block matrix defined by $M1... combined according
to $flag.  $flag takes one of the values $horizontal, $vertical or $diagonal. The
block matrix will contain zero values where the matricese passed could not give
a value.

Use:

 $block = &matrix::block($matrix::diagonal, M1, M2);

This would put a matrix in $block that had M1 and M2 on the diagonal, and zero
everywhere else.

=back

=head1 Using a matrix

=head2 Operators

=over 5

=item C<add>

Adds two matricese together.  Used to impliment the overloading of
the '+' operator.

Use:

 $Manswer = $M1 + $M2;

As for any matrix addition, $M1 and $M2 must both be matricese, both with
the same number of rows and columns.  If this is not the case then the
function returns C<undef>.  Otherwise, it returns a new matrix, containing the
sum of $M1 and $M2.

=item C<subtract>

Subtracts one matrix from another.  Used to impliment the overloading of
the '-' operator.

Use:

 $Manswer = $M1 - $M2;

As for any matrix subtraction, $M1 and $M2 must both be matricese, both with
the same number of rows and columns.  If this is not the case then the
function returns C<undef>.  Otherwise, it returns a new matrix, containing $M1
minus $M2.

=item C<multiply>

Multiplies two matricese, or a matrix and a scaler.  Used to impliment the
overloading of the '*' operator.

Use:

 $Manswer = $M1 * $M2;
 $Manswer = $s * $M;
 $Manswer = $M * $s;

When used to multiply by a scaler, a matrix scaled by the factor is returned.
When used for multiplying two matricese together, the number of columns in the first
matrix must equal the number of rows in the second.  If this is not so then
C<undef> is returned.

=item C<assign>

Sets one matrix equal to another by value.  Used to impliment the '=' operator.  It
is a wrapper around $N = new matrix $M, but is more intuitive and (I think) easier to read

Use:

 $N = $M;

$N and $M can now be changed independantly

=item C<equals>

Checks whether two matricese are equal.  Returns true if they are and false if they
are not.  Used to impliment the overloading of the '=' operator.

Use:

 $ans = $M1 == $M2;

The function will return true only if the two matricese are equivelent.  That is, they
must have the same number of rows and of columns.  Also, every element ij of the first
matrix must equal every element ij of the second.

=back

=head2 Variables

=over 5

=item C<$joinString>

This string is the one used to demarcate one element from the next.  It is a package
level variable, so is accesed like C<Ematrix::$joinString>.  It defaults to a single
space caracter.

=item C<$horizontal>

Constant to indicate a horizontal construction of a block matrix

=item C<$vertical>

Constant to indicate a vertical construction of a block matrix

=item C<$diagonal>

Constant to indicate a diagonal construction of a block matrix

=back

=head3 Data access

=over 5

=item C<rows>

Returns the number of rows in a matrix.  Assigning to this value will B<not> change the
shape of the matrix.

Use:

 $rows = $M->rows:

=item C<cols>

Returns the number of columns in a matrix.  Assigning to this value will B<not> change
the shape of the matrix.

=item C<component>

Allows you to set and/or return the component i, j of a matrix

Use:

 $val = $M->component(0, 3);
 $M->component(0, 2, 7);

As yet it does not support notation of the type C<$M->component($i, $j) = $val> as I
can not find any reasonably safe and legal way of accumplishing it.  Both forms
return the value of Matrix(i, j).  The assigment form returns the value of
matrix(i, j) post assigment - i.e. $M->component($i, $j, $val) returns a scaler of 
value $val.

=back

=head2 C<Assertions>

=over 5

=item C<isMatrix>

returns true if the reference is a matrix.  Otherwise, returns undef.

=item C<isSquare>

Returns true if the matrix is square and returns false otherwise.

=item C<isDiagonal>

Returns true if the matrix is diagonal and returns false otherwise.  Must be square, and all entries not on
the leading diagonal must return false.

=item C<isTriangular>

Returns true if the matrix is triangular, and false otherwise.  Must be square, and all entries below
the leading diagonal must return false.

=back

=head2 C<Other functions>

=over 5

=item C<toString>

Returns a string representation of a matrix.  Places $joinString  between
each element, and delimits each row with C<'\n'>.

=item C<transpose>

Returns a new matrix which is the transpose of your matrix.

=item C<det>

Will return determinant of matrix and undef if the matrix is not square.
Uses Det A = a00 for a matrix of 1 element, Det A = a00*a11 - a10*a01 for
a 2 by 2 matrix, and the Gausian elimination algorithm for anything larger.

=item C<inverse>

Returns a new matrix which is the inverse of your matrix, and undef
if there is not one.  Returns undef if the matrix is not square.

=item C<zero>

Sets the matrix to the zero matrix.  All elements become zero.  Alternatively,
calling matrix::&zero($i, $j) will return a new zero matrix $i by $j

=item C<identity>

Sets a matrix to the identity matrix.  All elements on the leading diagonal
become 1, and all other elements become zero.  It leaves the matrix unchangd
and returns C<undef> if the matrix is not square.  Alternatively, if called as
matrix::&identity($i) it will return a new identity matrix $i square

=item C<trace>

Returns the trace of the matrix - the sum of the leading diagonal.  If the
matrix is not square then it returns C<undef>.

=item C<rowScale> and C<colScale>

Scales row or column i by factor f

Use:

 $M->rowScale($i, $f);
 $M->colScale($i, $f);

=item C<rowSwap> and C<colSwap>

Swap row or column i with row j

Use:

 $M->rowSwap($i, $j);
 $M->colSwap($i, $j);

=item C<rowAdd> and C<colAdd>

Add s times row or column j to row i

Use:

 $M->rowAdd($i, $j, $s);
 $M->colAdd($i, $j, $s);

=item C<rowAddScale> and C<colAddScale>

Combine rowAdd and rowScale or colAdd and colScale into one function.  row or column
i becomes row i * s + j * t.

Use:

 $M->rowAddScale($i, $j, $s, $t);
 $M->colAddScale($i, $j, $s, $t);

=item C<echelon>

Uses row operations to transform the matrix to an echelon form matrix.

Use:

 $M->echelon;

Remember kids - this will destroy the original contence of $M.  If you wish to find an
echelon form of $M without destroying it, make a copy first!

 $N = $M;
 $N->toEchelon;

=item <rowCanonical>

Uses row operators to transform the matrix into it's row canonical form.  The same pravisoes
apply as for the echelon function.

Use:

 $M->rowCanonical;
 $E->rowCanonical(1);

In the first example, the matrix $M will be transformed into it's row canonical form.
In the second example, the matrix $E is presumed to already be an echelon matrix,
and will be further reduced to the row canonical form.

=back














